% %W% %G% 

:- module(topen, [topen/1,tclose/1]).

:- use_module(library(tcp)).
:- use_module(library(environ)).

:- dynamic address/1.
:- volatile address/1.

topen(Stream) :-
    address(Address),
    tcp_connect(Address, Socket),
    tcp_output_stream(Socket, Stream),
    write(Stream, '(server-eval-quickly ''').

tclose(Stream) :-
    put(Stream, 0')),
    put(Stream, 4),
    tcp_output_stream(Socket, Stream), !,
    tcp_shutdown(Socket).

:- initialization get_address(Address), assert(address(Address)).

get_address(address(Port,Host)):-
    environ('GNU_HOST', Host),
    (   environ('GNU_PORT', PortAtom)
    ->  atom_chars(PortAtom, PortChars), number_chars(Port, PortChars)
    ;   getuid(UID), Port is UID+21490
    ).

foreign(getuid, c, getuid([-integer])).

foreign_file(library(system(tcp_p)), [getuid]).

:- load_foreign_executable(library(system(tcp_p))),
   abolish(foreign_file, 2),
   abolish(foreign, 3).
